Subject: Re: bug#64966: Rockpro64 SBC not booting anymore after "gnu: [email-masked]: Use guile-fibers 1.3.1."

From: Ludovic Courtès <[email-masked]>
Date: Mon, 21 Aug 2023 17:00:26 +0200

Hi Denis,

Apologies for the delay.

Denis 'GNUtoo' Carikli <[email-masked]> skribis:

> With the commit right before c219c22cbd[1], my rockpro64 (ARM 64bit
> SBC) boots fine and I get a login prompt both on the attached display
> and serial port.
>
> With c219c22cbd[1] instead it blocks here (see the attached boot.log
> file for the full boot log):
>> [   33.762050] avdd: disabling
>
> I've attached the system.scm file I used for the test. It's being
> reused by a machine configuration in another file (rockpro64.scm) and
> I deploys the configuration with:
>> guix time-machine --commit=$(GUIX_COMMIT) -- deploy -L . rockpro64.scm
>
> References:
> -----------
> [1] commit c219c22cbdb62ba52b50ec8fb12bebce0b1dd459
>     gnu: [email-masked]: Use guile-fibers 1.3.1.
>     * gnu/packages/admin.scm (shepherd-0.10)[native-inputs, inputs]:
>       Replace GUILE-FIBERS-1.1 with GUILE-FIBERS-1.3.

I believe this is due to this bug:

  https://github.com/wingo/fibers/issues/89

How about this patch:

diff --git a/gnu/packages/admin.scm b/gnu/packages/admin.scm
index 65d2e387b5..cb698e82b8 100644
--- a/gnu/packages/admin.scm
+++ b/gnu/packages/admin.scm
@@ -385,9 +385,15 @@ (define-public shepherd-0.10
                (base32
                 "0v9ld9gbqdp5ya380fbkdsxa0iqr90gi6yk004ccz3n792nq6wlj"))))
     (native-inputs (modify-inputs (package-native-inputs shepherd-0.9)
-                     (replace "guile-fibers" guile-fibers-1.3)))
+                     (replace "guile-fibers"
+                       ;; Work around
+                       ;; <https://github.com/wingo/fibers/issues/89>.
+                       (if (target-aarch64?)
+                           guile-fibers-1.1
+                           guile-fibers-1.3))))
     (inputs (modify-inputs (package-inputs shepherd-0.9)
-              (replace "guile-fibers" guile-fibers-1.3)))))
+              (replace "guile-fibers"
+                (this-package-native-input "guile-fibers"))))))
 
 (define-public shepherd shepherd-0.9)

?

Thanks,
Ludo’.